namespace PkmnLib.Static.Species;

/// <summary>
/// Gender is a Pokémon characteristic.
///
/// Required for standard Pokémon functions, but somewhat controversial nowadays. Consider adding a feature
/// that allows for a more progressive gender system for those that want it?
/// </summary>
public enum Gender : byte
{
    /// The Pokémon has no gender.
    Genderless,

    /// <summary>
    /// The Pokémon is male.
    /// </summary>
    Male,

    /// <summary>
    /// The Pokémon is female.
    /// </summary>
    Female,
}