namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "bestow")]
public class Bestow : Script
{
    /// <inheritdoc />
    public override void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var user = move.User;
        var userHeldItem = user.RemoveHeldItemForBattle();
        var targetHeldItem = target.HeldItem;

        if (userHeldItem == null || targetHeldItem != null)
        {
            move.GetHitData(target, hit).Fail();
            return;
        }

        _ = target.SetHeldItem(userHeldItem);
    }
}