using System.Collections.Generic;
using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "dive")]
public class Dive : Script
{
    /// <inheritdoc />
    public override void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<DiveEffect>())
            return;

        move.User.Volatile.Add(new DigEffect(move.User));
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("dive_charge", new Dictionary<string, object>()
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public override void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<DiveEffect>());
    }
}